//
//  ncnnCommon.h
//  AVGesture
//
//  Created by xiaoyili on 2017/4/6.
//
//

#ifndef AVGesture_h
#define AVGesture_h

#include <string>
#include <cstdio>
#include <ctime>

using ::std::string;
#ifndef WIN32
#include <pthread.h>
pthread_mutex_t* AVLogDevLock();
#endif

#ifndef WIN32
#define AVLogFinal(filter, fmt, ...) {\
    time_t timep;\
    time (&timep);\
    char timeBuf[1024] = {0};\
    sprintf(timeBuf, "%s", asctime(gmtime(&timep)));\
    char fmtBuff[10240] = {0};\
    char logBuff[10240] = {0};\
    string file = __FILE__;\
    for (int i = (int)file.length() - 1; i >= 0; i--)\
    {\
        if (file[i] == '/')\
        {\
            file = file.substr(i + 1, file.length() - i - 1);\
            break;\
        }\
    }\
    snprintf(fmtBuff, 10240, "time:%sfilter:%s, file:%s:%d, func:%s, content:%s\r\n", timeBuf, filter, file.c_str(), __LINE__, __FUNCTION__, fmt);\
    snprintf(logBuff, 10240, (const char*)fmtBuff, ##__VA_ARGS__);\
    pthread_mutex_lock(AVLogDevLock());\
    printf("%s", logBuff);\
    pthread_mutex_unlock(AVLogDevLock());\
}
#define AVLogDev(filter, fmt, ...)
#else
#define AVLogFinal(filter, fmt, ...) {\
	time_t timep;\
    time (&timep);\
    char timeBuf[1024] = {0};\
    sprintf(timeBuf, "%s", asctime(gmtime(&timep)));\
    char fmtBuff[10240] = {0};\
    char logBuff[10240] = {0};\
    string file = __FILE__;\
    for (int i = (int)file.length() - 1; i >= 0; i--)\
    {\
        if (file[i] == '/')\
        {\
            file = file.substr(i + 1, file.length() - i - 1);\
            break;\
        }\
    }\
    sprintf(fmtBuff, "time:%sfilter:%s, file:%s:%d, func:%s, content:%s\r\n", timeBuf, filter, file.c_str(), __LINE__, __FUNCTION__, fmt);\
    sprintf(logBuff, (const char*)fmtBuff, ##__VA_ARGS__);\
	printf("%s", logBuff);\
}
#define AVLogDev(filter, fmt, ...)
#endif

#define __in__ 
#define __out__

typedef unsigned char U_CHAR;
typedef unsigned long long U_INT64;

namespace AVGesture
{
typedef enum _EImgFmt
{
    eRGBA,
    eBGRA
}EImgFmt;
}
#endif /* AVGesture_h */


